#include <stdlib.h>
#include <stdio.h>
#include <string.h>

/*
Observación: 
Se plantea una solución alternativa al problema propuesto por la letra.
Se toma posición de bit desde 0 a 31, en véz de 1 a 32 para un entero.

Ejemplo: 

Por simplicidad,imaginemos un char que ocupa 8 bits en memoria, 
las posiciones de bits serían las siguientes:      

char(1 byte): 01010000
Posiciones:   76543210

La posición 0 ocupa el lugar del bit menos significativo (LSB),
mientras que la posición 7 corresponde al bit más significativo (MSB).
*/

void ver_binario(unsigned int num){
    int i;
    for(i=sizeof(unsigned int)*8-1; i>=0;i--)
        printf("%d", (num >> i) & 1);
    printf("\n");
}

int main(int argc, char* argv[]){
    
    int num, a, b;
    unsigned int mask;
	if (argc<4)
	{
		printf("faltan parámetros en la entrada\n");
		return 0;
	}
	
	num=atoi(argv[1]);
	a=atoi(argv[2]);
	b=atoi(argv[3]);
	
    if ((a<0) || (b>sizeof(int)*8-1) || (a>b))
	{
		printf("Los argumentos deben estar entre 0 y 31 y 'a' debes ser menor igual a 'b' \n");
	}
	else
	{
		mask = ~0;
        mask = mask << a  &  mask >> (8*sizeof(unsigned  int) - b - 1);	
        ver_binario(mask & num);
	}
    return 0;
}
